var HeatingStart = 23;
var HeatingStop = 7;
/*   бойлер   */
var BoilerName = "BoilerTermostat/Name";
var BoilerONOFF = "BoilerTermostat/ON_OFF";
var BoilerScheduleMode = "BoilerTermostat/ScheduleMode";
var BoilerTemperature = "wb-mai6_51/IN 1 P Temperature";
var BoilerMaxTemperature = 70;
var BoilerSetpoint = "BoilerTermostat/Setpoint";
var BoilerHysteresis = "BoilerTermostat/Hysteresis";
var BoilerPressure = "wb-mai6_51/IN 5 P Voltage";  // пока не поставил датчик давления на бойлер ТУТ ДАВЛЕНИЕ КОТЛА
/*
0.5 bar = 0.667 В
0.8 bar = 0.767 В
1 bar = 0.833 В
2 bar = 1.167 В
2.8 bar = 1.433 В
3 bar = 1.500 В
4 bar = 1.833 В
6 bar = 2.500 В
*/
var BoilerMinPressure = 0.667;  //  0.667 В = 0.5 bar // потом заменить на 0.833 В = 1 bar
var BoilerMaxPressure = 2.5;    //  2.500 В = 6 bar
var BoilerMainRelayState = "wb-mio-gpio_70:2/IN9"; // если подаётся ток с клеммы S термореле бойлера на реле WB
var BoilerWBRelayState = "wb-mio-gpio_70:4/K1"; 
var BoilerABBRelayState = "wb-mio-gpio_70:2/IN11";
var BoilerVirtualPumpRelayState = "BoilerTermostat/VirtualPump"; // виртуальный насос чисто потому что в функции heatingRules нужен такой аргумент для унификации с котлом

var BoilerCirculationTimeout = 30000; // 30 секунд
var BoilerCirculationRelay = "wb-mr6cu_76/K4";
var BoilerCirculationButtons = ["wb-mr6c_120/Input 4 Double Press Counter",    "wb-mr6c_126/Input 5 Double Press Counter"];
var BoilerCirculationNames =  ["на первом этаже", "на втором этаже"];


/*   котёл   */
var KotelName = "KotelTermostat/Name";
var KotelONOFF = "KotelTermostat/ON_OFF";
var KotelScheduleMode = "KotelTermostat/ScheduleMode";
var KotelTemperature = "wb-mai6_51/IN 1 N Temperature";
var KotelMaxTemperature = 95;
var KotelSetpoint = "KotelTermostat/Setpoint";
var KotelHysteresis = "KotelTermostat/Hysteresis";
var KotelPressure = "wb-mai6_51/IN 5 P Voltage";
var KotelMinPressure = 0.667;  //  0.667 В = 0.5 bar
var KotelMaxPressure = 1.433;  //  1.433 В = 2.8 bar
var KotelBoilerRelayState = "wb-mio-gpio_70:2/IN2";   // если подаётся ток с термореле бойлера на предельное термореле котла 
var KotelMainRelayState = "wb-mio-gpio_70:2/IN1";   // если подаётся ток с предельного термореле котла на реле WB
var KotelWBRelayState = "wb-mio-gpio_70:4/K2";
var KotelABBRelayState = "wb-mio-gpio_70:2/IN12";
var KotelPumpRelayState = "wb-mr6cu_76/K2";

/*   полы   */
var PolyPressure = "wb-mai6_51/IN 6 P Voltage";
var PolyPumpRelayState = "wb-mr6cu_76/K1";




defineVirtualDevice("KotelTermostat", { 
    title: "Термостат котла",  
    cells: {
      Name: {
        title: "Название",
        type: "text",
        value: "Котёл",
      }, 
      ON_OFF: { // активация термостата 0-выкл 1-включен
        title: "Выключатель",
        type: "switch",
        value: false,
      }, 
      ScheduleMode: { // режим 0-ручной 1-по расписанию с 23 вечера до 7 утра
        title: "Работа по расписанию",
        type: "switch",
        value: false,
      },
      Pressure: {
        title: "Давление",
        type: "value",
        value: "",
        units: "бар",
        precision: 2,
      },
      Temperature: {
        title: "Температура",
        type: "value",
        value: "",
        units: "deg C",
        precision: 2,
      },
      Setpoint: { // уставка
        title: "Уставка",
        type: "range",
        value: 70,
          min: 40,
          max: 90,
        readonly: false,
      },
      Hysteresis: {
        title: "Гистерезис",
        type: "range",
        value: 10,
          min: 5,
          max: 20,
        readonly: false,     
      },
      Lock: { // блокировка в визуализации 0-снята 1-заблокирована
        title: "Блокировка изменений",
        type: "switch",
        value: false,
      }
  }
});




defineVirtualDevice("BoilerTermostat", {
    title: "Термостат бойлера",
    cells: {
      Name: {
        title: "Название",
        type: "text",
        value: "Бойлер",
      }, 
      ON_OFF: { // активация термостата 0-выкл 1-включен
        title: "Выключатель",
        type: "switch",
        value: false,
      }, 
      ScheduleMode: { // режим 0-ручной 1-по расписанию с 23 вечера до 7 утра
        title: "Работа по расписанию",
        type: "switch",
        value: false,
      },
      Temperature: {
        title: "Температура",
        type: "value",
        value: "",
        units: "deg C",
        precision: 2,
      },
      Setpoint: { // уставка
        title: "Уставка",
        type: "range",
        value: 50,
          min: 20,
          max: 70,
        readonly: false,
      },
      Hysteresis: {
        title: "Гистерезис",
        type: "range",
        value: 10,
          min: 5,
          max: 20,
        readonly: false,     
      },  
      Lock: { // блокировка в визуализации 0-снята 1-заблокирована
        title: "Блокировка изменений",
        type: "switch",
        value: false,
      },
      VirtualPump: { // виртуальный насос чисто потому что в функции heatingRules нужен такой аргумент для унификации с котлом
        title: "Виртуальный насос",
        type: "switch",
        value: false,
      }
  }
});





defineVirtualDevice("Poly", {
    title: "Тёплый пол",
    cells: {
      Name: {
        title: "Название",
        type: "text",
        value: "Тёплый пол",
      }, 
      Pressure: {
        title: "Давление",
        type: "value",
        value: "",
        units: "бар",
        precision: 2,
      },
      Pump: { 
        title: "Насос",
        type: "switch",
        value: false,
      }
  }
});



/*    ПРАВИЛА УПРАВЛЕНИЯ КОТЛОМ   */


// действия при изменении давления в бочке
defineRule("KotelPressureRule", { 
  whenChanged: KotelPressure, 
  then: function (newValue, devName, cellName) {

    dev['KotelTermostat/Pressure'] = (newValue/5-0.1)*(10/0.6667)        ;   // запись давления в ячейку виртуального устройства

    if ( newValue <= KotelMinPressure && newValue >= KotelMaxPressure ) {
      dev[KotelWBRelayState] = false;         // выключаем ТЭН
      dev[KotelPumpRelayState] = false;       // выключаем насос 
      // подаём оповещения
      SendTelegramMsg( 'Южный. Давление в бочке = ' + newValue + '. Предельное реле котла ' + dev[KotelMainRelayState] + '. Реле WB ' + dev[KotelWBRelayState] + '. Реле ABB ' + dev[KotelABBRelayState] + '. Реле насоса ' + dev[KotelPumpRelayState]);
      log.info( 'Южный. Температура котла = ' + newValue + '. Предельное реле котла ' + dev[KotelMainRelayState] + '. Реле WB ' + dev[KotelWBRelayState] + '. Реле ABB ' + dev[KotelABBRelayState] + '. Реле насоса ' + dev[KotelPumpRelayState]);
    }


  }
});


// действия при изменении температуры котла
defineRule("KotelTemperatureRule", { 
  whenChanged: KotelTemperature, 
  then: function (newValue, devName, cellName) {
    // действия, если температура выше предельной
    if (newValue >= KotelMaxTemperature) { 
      dev[KotelWBRelayState] = false;      // выключаем ТЭН
      dev[KotelPumpRelayState] = true;     // включаем насос 
      setTimeout( function () { dev[KotelPumpRelayState] = false; }, 60000 );         // выключаем насос через 60 секунд

      // подаём оповещения
      SendTelegramMsg( 'Южный. Температура котла = ' + newValue + '. Предельное реле котла ' + dev[KotelMainRelayState] + '. Реле WB ' + dev[KotelWBRelayState] + '. Реле ABB ' + dev[KotelABBRelayState] + '. Реле насоса ' + dev[KotelPumpRelayState]);
      log.info( 'Южный. Температура котла = ' + newValue + '. Предельное реле котла ' + dev[KotelMainRelayState] + '. Реле WB ' + dev[KotelWBRelayState] + '. Реле ABB ' + dev[KotelABBRelayState] + '. Реле насоса ' + dev[KotelPumpRelayState]);
    }
  }
});


// действия при изменении состояния главного термореле бойлера
defineRule("KotelBoilerRelayStateRule", { 
  whenChanged: KotelBoilerRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == true) { 
      SendTelegramMsg( 'Южный. На предельный термостат котла подаётся ток от бойлера.');
    }   
    if (newValue == false) { 
      dev[KotelWBRelayState] = false;    // если на реле не подаётся ток, то нет смысла держать реле WB включённым
    }

  }
});


// действия при изменении состояния предельного термореле котла
defineRule("KotelMainRelayStateRule", { 
  whenChanged: KotelMainRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == false) { 
      dev[KotelWBRelayState] = false;    // если на реле не подаётся ток, то нет смысла держать реле WB включённым
    }
  }
});


// запись состояния реле WB в ячейку виртуального устройства
defineRule("KotelWBRelayStateRule", { 
  whenChanged: KotelWBRelayState, 
  then: function (newValue, devName, cellName) {

  }
});


// запись состояния реле ABB в ячейку виртуального устройства
defineRule("KotelABBRelayStateRule", { 
  whenChanged: KotelABBRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == true) { 
      dev[KotelPumpRelayState] = true;     // включаем насос 
      SendTelegramMsg( 'Южный. Нагрев котла начат.' );
    }

    if (newValue == false) { 
      setTimeout( function () { dev[KotelPumpRelayState] = false; }, 60000 );         // выключаем насос через 60 секунд     
      if (dev[KotelMainRelayState] == true) {   // если реле АВВ выключилось, но предельный термостат не сработал, значит нагрев отключился либо по термостату WB, либо по термостату бойлера
        SendTelegramMsg( 'Южный. Нагрев котла закончен. Температура = ' + dev[KotelTemperature] + '. Реле WB ' + dev[KotelWBRelayState] + '. Настройка термостата WB = ' + dev[KotelSetpoint] + '. Выход реле из бойлера = ' + dev[KotelBoilerRelayState] );
      }
    }

  }
});


// запись состояния реле насоса в ячейку виртуального устройства
defineRule("KotelPumpRelayStateRule", { 
  whenChanged: KotelPumpRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == true) { 
      SendTelegramMsg( 'Южный. Насос котла ВКЛ.' );
    }
    if (newValue == false) { 
      SendTelegramMsg( 'Южный. Насос котла ВЫКЛ.' );
    }
  }
});


/*    КОНЕЦ ПРАВИЛ УПРАВЛЕНИЯ КОТЛОМ   */




/*    ПРАВИЛА УПРАВЛЕНИЯ БОЙЛЕРОМ   */


// действия при изменении давления в бойлере
defineRule("BoilerPressureRule", { 
  whenChanged: BoilerPressure, 
  then: function (newValue, devName, cellName) {
    if ( newValue <= BoilerMinPressure && newValue >= BoilerMaxPressure ) {
      dev[BoilerWBRelayState] = false;             // выключаем ТЭН
      dev[BoilerCirculationRelay] = false;     // выключаем циркуляционный насос 
      // подаём оповещения
      SendTelegramMsg( 'Южный. Давление в бойлере = ' + newValue + '. Механическое реле бойлера ' + dev[BoilerMainRelayState] + '. Реле WB ' + dev[BoilerWBRelayState] + '. Реле ABB ' + dev[BoilerABBRelayState] + '. Реле циркуляционного насоса ' + dev[BoilerCirculationRelay] );
      log.info( 'Южный. Давление в бойлере = ' + newValue + '. Механическое реле бойлера ' + dev[BoilerMainRelayState] + '. Реле WB ' + dev[BoilerWBRelayState] + '. Реле ABB ' + dev[BoilerABBRelayState] + '. Реле циркуляционного насоса ' + dev[BoilerCirculationRelay] );
    }
  }
});


// действия при изменении температуры бойлера
defineRule("BoilerTemperatureRule", { 
  whenChanged: BoilerTemperature, 
  then: function (newValue, devName, cellName) {
    dev['BoilerTermostat/Temperature'] = newValue;   // запись температуры в ячейку виртуального устройства

    // действия, если температура выше предельной
    if (newValue >= BoilerMaxTemperature) { 
      dev[BoilerWBRelayState] = false;          // выключаем ТЭН
      // подаём оповещения
      SendTelegramMsg( 'Южный. Температура бойлера = ' + newValue + '. Предельное реле бойлера ' + dev[BoilerMainRelayState] + '. Реле WB ' + dev[BoilerWBRelayState] + '. Реле ABB ' + dev[BoilerABBRelayState] );
      log.info( 'Южный. Температура бойлера = ' + newValue + '. Предельное реле бойлера ' + dev[BoilerMainRelayState] + '. Реле WB ' + dev[BoilerWBRelayState] + '. Реле ABB ' + dev[BoilerABBRelayState] );
    }
  }
});


// действия при изменении состояния главного механического термореле бойлера
defineRule("BoilerMainRelayStateRule", { 
  whenChanged: BoilerMainRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == false) { 
      dev[BoilerWBRelayState] = false;          // выключаем реле WB
      SendTelegramMsg( 'Южный. Термостат бойлера отключил нагрев. Температура = ' + dev[BoilerTemperature] );
      log.info( 'Южный. Термостат бойлера отключил нагрев. Температура = ' + dev[BoilerTemperature] );
    }

  }
});


// запись состояния реле WB в ячейку виртуального устройства
defineRule("BoilerWBRelayStateRule", { 
  whenChanged: BoilerWBRelayState, 
  then: function (newValue, devName, cellName) {


  }
});


// запись состояния реле ABB в ячейку виртуального устройства
defineRule("BoilerABBRelayStateRule", { 
  whenChanged: BoilerABBRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == true) { 
      SendTelegramMsg( 'Южный. Нагрев бойлера начат. Температура = ' + dev[BoilerTemperature] );
    }
    if (newValue == false) { 
      if (dev[BoilerMainRelayState] == true) {   // если реле АВВ выключилось, но механическое термореле всё ещё горит, значит нагрев отключился по термостату WB
        SendTelegramMsg( 'Южный. Нагрев бойлера закончен. Температура = ' + dev[BoilerTemperature] + '. Реле WB ' + dev[BoilerWBRelayState] + '. Настройка термостата WB = ' + dev[BoilerSetpoint] );
      }

    }
  }
});



// запустить насос циркуляции ГВС при двойном нажатии выключателя в ванной или в сортире
defineRule("BoilerCirculationControlRule", {
  whenChanged: BoilerCirculationButtons,
  then: function (newValue, devName, cellName) {
    var index = BoilerCirculationButtons.indexOf(devName + '/' + cellName);
    
    dev[BoilerCirculationRelay] = true;
    setTimeout(function (){ dev[BoilerCirculationRelay]=false; }, BoilerCirculationTimeout);

    SendTelegramMsg('В Южном кто-то пошёл мыться ' + BoilerCirculationNames[index]);

  }
});

/*    КОНЕЦ ПРАВИЛ УПРАВЛЕНИЯ БОЙЛЕРОМ   */




/*    ПРАВИЛА УПРАВЛЕНИЯ ПОЛАМИ   */

// действия при изменении давления в полах
defineRule("PolyPressureRule", { 
  whenChanged: PolyPressure, 
  then: function (newValue, devName, cellName) {

    dev['Poly/Pressure'] = (newValue/5-0.1)*(10/0.6667)        ;   // запись давления в ячейку виртуального устройства

    }

});


// автоматическое включение насоса в отопительный сезон
defineRule("PolyPumpSwitching", { 
  whenChanged: PolyPumpRelayState, 
  then: function (newValue, devName, cellName) {
    if (newValue == false) {
      dev[PolyPumpRelayState] = true;
      SendTelegramMsg('В Южном насос тёплого пола запущен.');      
    }

    SendTelegramMsg('В Южном насос тёплого пола работает.'); 

    }

});




/*    КОНЕЦ ПРАВИЛ УПРАВЛЕНИЯ ПОЛАМИ   */






/*

Режим работы котла
1) Проверка давления. 
Нормальный режим 1,8...2,2 бар. 
Если стало 1,5 или  2,5, то высылаем смс в телегу. 
Если стало 1 или 3, то останавливаем котёл. 
2) Проверка температуры
3) Проверка времени
Котёл включается с 23-00 по 07-00 при температуре датчика менее 70 градусов и отключается при 90.

Режим работы бойлера 
Насос бойлера работает всё время при условии:
1) Температура в ТА больше температуры бойлера
2) Температура включения насоса 50, выключение при 60.

Режим работы полов 
1) Проверка давления. 
Нормальный режим 1,8...2,2 бар. 
Если стало 1,5 или  2,5, то высылаем смс в телегу. 
Если стало 1 или 3, то выключаем  насос. 
2) Насос включается в 5 утра и выключается в 7 вечера.

*/




function heatingRules(name, temperature, setpoint, hysteresis, pressure, MinPressure, MaxPressure, MainRelayState, WBRelayState, ABBRelayState, PumpRelayState) { 

  // SendTelegramMsg('Время ' + time.getHours() + '. heatingRules started в Южном.');
  // log.info('Время ' + time.getHours() + '. heatingRules started в Южном.');


  // запускаем термостат только если на главном реле есть напряжение
  if ( dev[MainRelayState] == true ) {


      if (dev[pressure] <= MinPressure) {
          dev[WBRelayState] = false;
          dev[PumpRelayState] = false;
      }

      else if (dev[pressure] >= MaxPressure) {
          dev[WBRelayState] = false;
          dev[PumpRelayState] = false;
      }

/* ===================   тут работаем   =============================  */
      else if (dev[pressure] > MinPressure && dev[pressure] < MaxPressure) {  // pressure > MinPressure   И   pressure < MaxPressure 

          if ( dev[temperature] <= (dev[setpoint] - dev[hysteresis]) ) { // если температура датчика меньше, чем (уставка минус гистерезис)
              dev[PumpRelayState] = true;
              dev[WBRelayState] = true;
          }

          else if ( dev[temperature] > (dev[setpoint] - dev[hysteresis]) && dev[temperature] < dev[setpoint] ) {
          // тут ничего не делаем (либо идёт нагрев либо остывание)
            dev[PumpRelayState] = true;
          }
          
          else if ( dev[temperature] == dev[setpoint] ) { // если температура датчика достигла уставки выключить нагрев
              dev[PumpRelayState] = true;
              dev[WBRelayState] = false;
          }
          
          else if ( dev[temperature] > dev[setpoint] ) { // если температура датчика больше уставки выключить нагрев
                  dev[WBRelayState] = false;
                  dev[PumpRelayState] = true;
          }
            
          else {  // на всякий случай во всех других ситуациях вырубаем ТЭН
              dev[WBRelayState] = false;
          }

      }
/* ===================   конец работы   =============================  */

      else {  // на всякий случай во всех других ситуациях вырубаем ТЭН, например WBRelayState undefined
          dev[WBRelayState] = false;
      }
  
  }

}

function TermostatController(name, onoff, scheduleMode, temperature, setpoint, hysteresis, pressure, MinPressure, MaxPressure, MainRelayState, WBRelayState, ABBRelayState, PumpRelayState, HeatingStart, HeatingStop) {

  defineRule( {
    whenChanged: [onoff, scheduleMode, setpoint, hysteresis, temperature, pressure], 
    then: function (newValue, devName, cellName) {

      time = new Date(); //Текущее время


      if (dev[onoff]) { // если термостат включён
            // log.info( 'Термостат включён');

        if (dev[scheduleMode]) { // если термостат работает по расписанию
            // тут ТЭН нельзя включать вручную
            // то есть в виджете выключатель реле "wb-mio-gpio_70:4/K1"
            // должен быть спрятан или виден, но заблокирован для нажатия
            // log.info('scheduleMode ON - нагрев по расписанию ночью');

          if (time.getHours() < HeatingStop || time.getHours() == HeatingStart ) { // время меньше  7 часов  ИЛИ  равно 23 часам, то есть с 23 ночи до 7 утра
            // log.info('Началось ночное время нагрева по расписанию');
            heatingRules(name, temperature, setpoint, hysteresis, pressure, MinPressure, MaxPressure, MainRelayState, WBRelayState, ABBRelayState, PumpRelayState);
          }

          else  { // с 7 утра до 23 ночи
            dev[WBRelayState] = false;
          }
        }

        else { // scheduleMode == false, то есть термостат работает вручную по кнопке
            // тут ТЭН надо включать вручную
            // то есть в виджете выключатель реле "wb-mio-gpio_70:4/K1"
            // должен быть виден и активен для нажатия
            heatingRules(name, temperature, setpoint, hysteresis, pressure, MinPressure, MaxPressure, MainRelayState, WBRelayState, ABBRelayState, PumpRelayState);
        }
      }

      else { // если термостат выключён, то нагрев не работает
        dev[WBRelayState] = false; 
      } 

    }

  });

}






defineRule("cron minute timer", { // задание, которое выполняется каждую минуту
  when: cron("00 * * * * *"),
  then: function () {

    TermostatController(BoilerName, BoilerONOFF, BoilerScheduleMode, BoilerTemperature, BoilerSetpoint, BoilerHysteresis, BoilerPressure, BoilerMinPressure, BoilerMaxPressure, BoilerMainRelayState, BoilerWBRelayState, BoilerABBRelayState, BoilerVirtualPumpRelayState, HeatingStart, HeatingStop);

    TermostatController(KotelName, KotelONOFF, KotelScheduleMode, KotelTemperature, KotelSetpoint, KotelHysteresis, KotelPressure, KotelMinPressure, KotelMaxPressure, KotelMainRelayState, KotelWBRelayState, KotelABBRelayState, KotelPumpRelayState, HeatingStart, HeatingStop);



    }
});